////////////////////////////////////////////////////////
//   udserver v0.01
//   External for Gem and Pure Data to convert an image to jpg and send it 
//	 via Unix Domain Sockets.
//
//   (c) 2012-2013 Santi Noreña. librediaserver@gmail.com 	
//
//	 GPL License.
//
/////////////////////////////////////////////////////////

#include <stdio.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <unistd.h>
#include <string.h>
#include "m_pd.h"

#define SOCKET_PATH "/tmp/socket"

static t_class *udserver_class;

typedef struct _udserver {
	t_object            x_obj;
	t_outlet            *x_out;
  int msgsock;
  int srvsock;
} t_udserver;

static void udserver_bang(t_udserver *x)
{
  struct sockaddr_un clt_addr, address;
  int rval, done;
  socklen_t len;    
  static char buffer[1024];

 // Init the Unix Socket 
	 x->srvsock = socket(AF_UNIX, SOCK_STREAM, 0);
	 if(x->srvsock < 0)
 	 {
  	 post("create socket failed");
  	 return;
 	 }
    // start with a clean address structure
   memset(&address, 0, sizeof(struct sockaddr_un));
   strcpy(address.sun_path, SOCKET_PATH);
   address.sun_family = AF_UNIX;
   unlink(SOCKET_PATH);   
   if (bind (x->srvsock, (struct sockaddr *)&address, strlen(address.sun_path) + sizeof(address.sun_family)) < 0) {
      post("Can not Bind to Socket");
  } else {
      post("Socket binded %s", address.sun_path);
      if (listen(x->srvsock, 1) < 0) {
        post("Can not listen");
        return;
     } else {
        post("server listening...");
     }
  } 
  len = sizeof(clt_addr);    
  for (;;) { 
//    msgsock = accept(x->srvsock, 0, 0); // Acepta en srvsock. Mejor?
    x->msgsock = accept(x->srvsock, (struct sockaddr*)&clt_addr, &len);
    if (x->msgsock > 0) {
      post("Acepted connection");
      done = 0;
      do {
        memset(buffer, 0, 1024);
//      bzero(x_buf, sizeof(x_buf));
        if ((rval = recv(x->msgsock, buffer, 1024, 0)) <= 0) {
          post("err reading message");
          done = 1;
        }
        if (!done) {
          post("done");
          post("--> %s", buffer);
      	 outlet_symbol(x->x_out, gensym(buffer));
         done = 1;        
        }
      } while (!done);
    }
    close(x->msgsock);  
  }
}

static void udserver_close(t_udserver *x)
{
  close(x->msgsock);
  close(x->srvsock);
  unlink(SOCKET_PATH);
}

static void *udserver_new() 
{
	t_udserver *x = (t_udserver *)pd_new(udserver_class);
  x->x_out = outlet_new((t_object *)x, &s_symbol);
	return (x);
}

void udserver_setup(void) 
{
	udserver_class = class_new(gensym("udserver"),(t_newmethod)udserver_new,0,sizeof(t_udserver),0,0); 
	class_addbang(udserver_class,(t_method) udserver_bang);
	class_addmethod(udserver_class, (t_method)udserver_close, gensym("close"), A_NULL, 0);
}
